from . import interp
import io
import typing

__all__ = ['load', 'loads', 'load_file']

def load(stream: typing.TextIO, name: str = "<unknown>", globals: dict[str, typing.Any] = {}):
    i = interp.Interp(stream, name)
    i.update(globals)
    return i.run()

def loads(src: str, name: str = "<string>", globals: dict[str, typing.Any] = {}):
    with io.StringIO(src) as stream:
        return load(stream, name, globals)
    
def load_file(path: str, globals: dict[str, typing.Any] = {}):
    with open(path, 'r') as fl:
        return load(fl, path, globals)